﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class adm_sc_engine_youtube_status_Process : System.Web.UI.Page
{
    public long TotalRecords
    {
        get
        {
            if (ViewState["TotalRecords"] != null)
                return (long)ViewState["TotalRecords"];
            else
                return 0;
        }
        set
        {
            ViewState["TotalRecords"] = value;
        }
    }

    public int MaxRecords
    {
        get
        {
            if (ViewState["MaxRecords"] != null)
                return (int)ViewState["MaxRecords"];
            else
                return 0;
        }
        set
        {
            ViewState["MaxRecords"] = value;
        }
    }

    public string CategoryID
    {
        get
        {
            if (ViewState["CategoryID"] != null)
                return ViewState["CategoryID"].ToString();
            else
                return "all";
        }
        set
        {
            ViewState["CategoryID"] = value;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            if (Request.Params["id"] != null)
            {
                this.TotalRecords = VideoBLL.Count_Videos("all");
                if (this.TotalRecords == 0)
                {
                    Config.ShowMessageV2(msg, "No videos found!", "Error!", 0);
                    return;
                }
                this.MaxRecords = Convert.ToInt32(Request.Params["id"]);
                if (this.MaxRecords == 7)
                    this.MaxRecords = 500;
                else if (this.MaxRecords > 10000)
                    this.MaxRecords = 10000;

                GenerateLinks();

            }
            else
            {
                Config.ShowMessageV2(msg, "Error occured while processing videos", "Success!", 1);
                return;
            }
        }
    }

    private void GenerateLinks()
    {
        StringBuilder str = new StringBuilder();

        int total_links = (int)Math.Ceiling((double)this.TotalRecords / (double)this.MaxRecords);
        int i = 0;
        long start =0;
        long last = this.MaxRecords;
        if (last > this.TotalRecords)
            last = this.TotalRecords;
        int pagenumber = 1;
        str.Append("<h2>Total Records: " + this.TotalRecords + "</h2><br />");
        for (i = 0; i <= total_links - 1; i++)
        {
            
            str.Append("<a class=\"big-text bold\" href=\"validate.aspx?pg=" + pagenumber + "&max=" + this.MaxRecords + "\" target=\"_blank\" title=\"Validate videos from " + start + " to " + last + " video records\">Process " + start + " - " + last + " Videos</a>");
            str.Append("<br />");
            str.Append("<br />");
            start = last + 1;
            pagenumber++;
            last = last + this.MaxRecords;
            if (last > this.TotalRecords)
                last = this.TotalRecords;
        }
        lst.InnerHtml = str.ToString();
    }
}