﻿<%@ WebHandler Language="C#" Class="favorites" %>

using System;
using System.Web;
using System.Text;
using System.Collections;

public class favorites : IHttpHandler {

    // This handle is used to add media (video | audio file) to favorites

    private int FavType = 0; // 0: video, audio, 1: qa fav, 2: gallery or album
    private long ContentID = 0;
    private string UserName = ""; // User who added media in his / her favorite lis
    private string Author_UserName = ""; // User who are actually owner of media
    private string Message = "";
    private int _Favorites = 0;
    private int MediaType = 0; // 0: video, 1: audio
    private string ElementID = ""; // div element id where you want to load box with close link

    public void ProcessRequest(HttpContext context)
    {
        context.Response.ContentType = "text/plain";
        if (context.Request.Params["id"] != null)
            this.ContentID = Convert.ToInt64(context.Request.Params["id"]);
        if (context.Request.Params["usr"] != null)
            this.UserName = context.Request.Params["usr"].ToString();
        if (context.Request.Params["ausr"] != null)
            this.Author_UserName = context.Request.Params["ausr"].ToString();
        if (context.Request.Params["mtp"] != null)
            this.MediaType = Convert.ToInt32(context.Request.Params["mtp"]);
        if (context.Request.Params["favt"] != null)
            this._Favorites = Convert.ToInt32(context.Request.Params["favt"]);
        if (context.Request.Params["elid"] != null)
            this.ElementID = context.Request.Params["elid"].ToString();

        if (context.Request.Params["ftype"] != null)
            this.FavType = Convert.ToInt32(context.Request.Params["ftype"]);
        
        
        this.Message = Generate_Output();
        context.Response.Write(this.Message);
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }


    private string Generate_Output()
    {  
        //**********************************************************
        // Generate Output Panel
        //**********************************************************
        StringBuilder str = new StringBuilder();
        string media = "video";
        string _url = Config.GetUrl();
        string fav_url = _url + "myaccount/myfavorites.aspx";
        if (this.FavType == 2)
        {
            media = "album";
            if(this.MediaType==1)
                fav_url = _url + "myaccount/audio/albums/favorites.aspx";
            else
                fav_url = _url + "myaccount/albums/favorites.aspx";
        }
        else if (this.MediaType == 1)
        {
            media = "audio";
            fav_url = _url + "myaccount/audio/myfavorites.aspx";
        }

        // check authentication
        if (this.UserName=="")
        {
            string sign_in = "<a href=\"" + Config.GetUrl() + "Login.aspx?ReturnUrl=" + Config.Return_Current_Page() + "\" class=\"bold\">Sign In</a>";
            string sign_up = "<a href=\"" + Config.GetUrl() + "Register.aspx\" class=\"bold\">Sign Up</a>";
            str.Append("" + sign_in + " or " + sign_up + " now!");
            return Config.SetHiddenMessage_v2(str.ToString(), this.ElementID, true, 2);
        }

        // check your own video
        if (this.Author_UserName == this.UserName)
        {
            str.Append("Can't add your own " + media + " to your <a href=\"" + fav_url + "\">" + Resources.vsk.favorites + "</a>.");
            return Config.SetHiddenMessage_v2(str.ToString(), this.ElementID, true, 0);
        }
        
        if (Favorites.Check_Favorites(this.UserName, this.ContentID, this.FavType))
        {
            str.Append("You already add this " + media + " to your <a href=\"" + fav_url + "\">" + Resources.vsk.favorites + "</a>.");
            return Config.SetHiddenMessage_v2(str.ToString(), this.ElementID, true, 0);
        }

       
        Favorites.Add(this.UserName, this.ContentID, this.MediaType, FavType);

        // increment favorite video state
        this._Favorites++;
        VideoBLL.Update_Field(this.ContentID, this._Favorites.ToString(), "favorites");
        str.Append(media.ToUpper() + " has been <strong>added</strong> to your <a href=\"" + fav_url + "\">" + Resources.vsk.favorites + "</a>.");
        // wrap output
        return Config.SetHiddenMessage_v2(str.ToString(), this.ElementID, true, 4);

    }

  

}