﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class modules_action_v2 : System.Web.UI.UserControl
{
   
    public int ToolbarSize = 1; // 0: mini, 1: normal, 2: large
    public int ToolbarTheme = 0; // 0: default, 1: primary, 2: warning,3: danger, 4: info, 5: inverse, 5: success
    public int RatingType = 0; // 0: like / dislike, 1: start rating
    public bool isEmbed = true;
    public bool isPlaylist = true;
    public bool isFavorites = true;
    public bool isShare = true;
    public bool isFlag = true;
    public bool isDownload = true;
    public bool isViews = true;
    public bool isDetailViewStats = true;
    private int _type = 0; // 0: video, audio, 1: comment adv points, 2: photo rating , 3: blog rating etc
    private int _mediatype = 0; // 0: video, 1: audio (only used in video or audio section)
    private long _contentid = 0;
    private string _username = ""; // content author
    private string _currentusername = ""; // currently logged in username
    
    private int _liked = 0;
    private int _disliked = 0;
    private int _favorites = 0;
    private string _videopath = "";
    private string _videofilename = "";
    private string _content_type = "video";
    public int isRating = 1; // 1: Rating On, 0: Rating Off
    
    public long ContentID
    {
        set { _contentid = value; }
        get { return _contentid; }
    }

    public string UserName
    {
        set { _username = value; }
        get { return _username; }

    }

    public string Current_UserName
    {
        set { _currentusername = value; }
        get { return _currentusername; }
    }

    public int Liked
    {
        set { _liked = value; }
        get { return _liked; }
    }

    public int Disliked
    {
        set { _disliked = value; }
        get { return _disliked; }
    }

    public int Type
    {
        set { _type = value; }
        get { return _type; }
    }

    public int MediaType
    {
        set { _mediatype = value; }
        get { return _mediatype; }
    }

    public int Favorites
    {
        set { _favorites = value; }
        get { return _favorites; }
    }

    public string VideoPath
    {
        set { _videopath = value; }
        get { return _videopath; }

    }

    public string VideoFileName
    {
        set { _videofilename = value; }
        get { return _videofilename; }
    }

    public string Content_Type
    {
        set { _content_type = value; }
        get { return _content_type; }
    }

    // Star Ratings
    public double Avg_Ratings = 0;
    public int TotalRatings = 0;
    public double Ratings = 0;
    public int Comments=0;
    public int Views=0;

    protected string rating_handler_path = "";
    protected string favorite_handler_path = "";
    protected string playlist_handler_path = "";
    protected string playlist_post_path = "";
    protected string flag_post_path = "";
    protected string flag_submit_path = "";
    protected string share_path = "";
    protected string embed_path = "";
    protected string stat_path = "";
    protected string rating_parameters = "";
    protected string favorite_parameters = "";
    protected string playlist_parameters = "";
    protected string playlist_post_parameters = "";
    protected string flag_post_parameters = "";
    protected string flag_submit_parameters = "";
    protected string share_parameters = "";
    protected string embed_parameters = "";
    protected string stat_parameters = "";

    // --> Custom Button Options --> Only required for photo galleries
    public bool PhotoGalleryOptions = false; // Enable photo gallery custom option buttons, (normal, original, slideshow)
    public bool ShowOriginalButton = false;
    public bool ShowNormalButton = false;
    public bool ShowSlideShowButton = false;
    public string GalleryDefaultLink = "";

    // --> Custom Button Options --> Only required for photo preview page
    public bool PhotoOptions = false;
    public string PhotoDownloadLink = "";
    // --> Close Custom Option Buttons
    protected void Page_PreRender(object sender, EventArgs e)
    {       
       Generate_Buttons();
    }

    private void Generate_Buttons()
    {
        StringBuilder str = new StringBuilder();
        string like_css = " likeact";
        string dislike_css = " dislikeact";
        string playlist_css = " plyact";
        string fav_css = " favact";
        string flag_css = " flagact";
        if (!Page.User.Identity.IsAuthenticated)
        {
            // set hidden message to show if sign in or sign up required
            string sign_in = "<a href=\"" + Config.GetUrl() + "Login.aspx?ReturnUrl=" + Server.UrlEncode(Config.Return_Current_Page()) + "\" class=\"bold\">" + Resources.vsk.signin + "</a>";
            string sign_up = "<a href=\"" + Config.GetUrl() + "Register.aspx\" class=\"bold\">" + Resources.vsk.signup + "</a>";
            // set sign in value in msg_sigin inorder to avoid any conflict between loading action / sign in action
            Config.SetHiddenMessage_v2(msg_signin, sign_in + " or " + sign_up + " now!", "shw_sign_lgn", false, 2);
            if (Config.isLoginRequired_Rating())
            {
                // admin can toggle on | off login required option
                like_css = " nologincss";
                dislike_css = " nologincss";
            }
            playlist_css = " nologincss";
            fav_css = " nologincss";
            flag_css = " nologincss";
        }
        else
        {
            this.Current_UserName = Page.User.Identity.Name;
        }
        string _rootpath = Config.GetUrl();
        if (this.isRating == 1)
        {
            // if rating enabled for selected content
            rating_handler_path = _rootpath + "handlers/rating/like.ashx";
            rating_parameters = "t=" + this.Type + "&mtp=" + this.MediaType + "&id=" + this.ContentID + "&usr=" + this.Current_UserName + "&lk=" + this.Liked + "&dlk=" + this.Disliked + "&rtype=" + RatingType + "&ratings=" + this.Ratings + "&aratings=" + this.Avg_Ratings + "&tratings=" + this.TotalRatings;
        }
        string btn_size_css = "btn-small";
        switch (this.ToolbarSize)
        {
            case 0:
                btn_size_css = "btn-mini";
                break;
            case 1:
                btn_size_css = "btn-small";
                break;
            case 2:
                btn_size_css = "btn-large";
                break;
        }
        string btn_theme_css = "";
        string btn_icon_css = "";
        if (this.ToolbarTheme > 0)
        {
            btn_icon_css = " icon-white";
            switch (this.ToolbarTheme)
            { 
                case 1:
                    btn_theme_css = "btn-primary ";
                    break;
                case 2:
                    btn_theme_css = "btn-warning ";
                    break;
                case 3:
                    btn_theme_css = "btn-danger ";
                    break;
                case 4:
                    btn_theme_css = "btn-info ";
                    break;
                case 5:
                    btn_theme_css = "btn-inverse ";
                    break;
                case 6:
                    btn_theme_css = "btn-success ";
                    break;
            }
        }
        str.Append("<div class=\"well btn-toolbar actionbar\">\n");
        if (this.RatingType == 0)
        {
            string _disabled = "";
            if (this.isRating == 0)
            {
                _disabled = " disabled";
            }
            str.Append("<div class=\"btn-group\">\n");
            str.Append("<button id=\"lk_0\" class=\"btn " + btn_theme_css + "" + btn_size_css + "" + like_css + " ilike\" title=\"I like this\"" + _disabled + "><i class=\"ui-adv-icon ui-adv-icon-good iclike\"></i>&nbsp;Like</button>\n");
            str.Append("<button id=\"lk_1\" class=\"btn " + btn_theme_css + "" + btn_size_css + "" + dislike_css + " idislike\" title=\"I dislike this\"" + _disabled + "><i class=\"ui-adv-icon ui-adv-icon-bad idislike\"></i></button>\n");
            str.Append("</div>\n"); // --> Like / Dislike Button Group
        }
        else
        {
            // five star rating system.
            str.Append("<div class=\"btn-group\">\n");
            string frating = " rcss";
            string first_title = "1 out of 5";
            string second_title = "2 out of 5";
            string third_title = "3 out of 5";
            string fourth_title = "4 out of 5";
            string fifth_title = "5 out of 5";
            if (this.isRating == 0)
            {
                frating = "";
                string dismsg= "Rating disabled on this " + Content_Type;
                first_title = dismsg;
                second_title = dismsg;
                third_title = dismsg;
                fourth_title = dismsg;
                fifth_title = dismsg;
            }
            str.Append("<ul class='star-rating'>\n");
            str.Append("<li class='current-rating' style=\"width:" + Calculate_Ratings() + "px;\">Currently " + Math.Round(this.Avg_Ratings,2) + "/5 Stars.</li>\n");
            str.Append("<li><a href='#' title='" + first_title + "' class='one-star" + frating + "'>1</a></li>\n");
            str.Append("<li><a href='#' title='" + second_title + "' class='two-stars" + frating + "'>2</a></li>\n");
            str.Append("<li><a href='#' title='" + third_title + "' class='three-stars" + frating + "'>3</a></li>\n");
            str.Append("<li><a href='#' title='" + fourth_title + "' class='four-stars" + frating + "'>4</a></li>\n");
            str.Append("<li><a href='#' title='" + fifth_title + "' class='five-stars" + frating + "'>5</a></li>\n");
            str.Append("</ul>\n");
            str.Append("</div>\n");
        }
        if(this.isPlaylist || this.isFavorites || this.isDownload)
        {
            // show this option if playlist or favorite is on
            str.Append("<div class=\"btn-group\">\n");
            str.Append("<button class=\"btn " + btn_theme_css + "" + btn_size_css + " dropdown-toggle\" data-toggle=\"dropdown\" title=\"Add to playlist or favorites\">Add to <span class=\"caret\"></button></a>\n");
            str.Append("<ul class=\"dropdown-menu\">\n");
            if (this.isFavorites)
            {
                int favtype = 0;
                if (this.Type == 9) // gallery or album
                    favtype = 2;
                favorite_handler_path = _rootpath + "handlers/media/favorites.ashx";
                favorite_parameters = "id=" + this.ContentID + "&usr=" + this.Current_UserName + "&ausr=" + this.UserName + "&mtp=" + this.MediaType + "&favt=" + this.Favorites + "&ftype=" + favtype;
                str.Append("<li><a class=\"" + fav_css + "\" href=\"#\">Add to favorite</a>\n");
            }
            if (this.isPlaylist)
            {
                playlist_handler_path = _rootpath + "handlers/media/loadplaylists.ashx";
                playlist_post_path = _rootpath + "handlers/media/addtoplaylist.ashx";
                playlist_parameters = "id=" + this.ContentID + "&usr=" + this.Current_UserName + "&mtp=" + this.MediaType + "&aid=" + msg.ClientID;
                playlist_post_parameters = "id=" + this.ContentID + "&usr=" + this.UserName + "&mtp=" + this.MediaType;
                str.Append("<li><a class=\"" + playlist_css + "\" href=\"#\">Add to playlist</a>\n");
            }
            if (this.isDownload && Site_Settings.Feature_Downloads==1)
                str.Append("<li><a href=\"" + _rootpath + "download/get.ashx?id=" + this.ContentID + "\">Download " + Content_Type + "</a>\n");
            str.Append("</ul>\n");
            str.Append("</div>\n");
        }
        if (this.isShare || this.isEmbed)
        {
            share_path = _rootpath + "handlers/media/share.ashx";
            embed_path = _rootpath + "handlers/media/embedvideo.ashx";
            share_parameters = "tp=" + this.Content_Type;
            embed_parameters = "usr=" + this.UserName + "&vfn=" + this.VideoFileName + "&vpath=" + this.VideoPath + "&mtp=" + this.MediaType;
            str.Append("<div class=\"btn-group\">\n");
            str.Append("<button class=\"btn " + btn_theme_css + "" + btn_size_css + " ishare\" title=\"Share or embed this " + Content_Type + "\">Share</button>\n");
            str.Append("</div>\n");
        }
        if (this.isFlag)
        {
            flag_submit_path = _rootpath + "handlers/abuse/postabuse.ashx";
            flag_post_path = _rootpath + "handlers/abuse/flag.ashx";
            flag_post_parameters = "t=" + this.Type + "&id=" + this.ContentID + "&usr=" + this.UserName + "&mtp=" + this.MediaType;
            flag_submit_parameters = "t=" + this.Type + "&id=" + this.ContentID + "&usr=" + this.UserName + "&mtp=" + this.MediaType;
   
            str.Append("<div class=\"btn-group\">\n");
            str.Append("<button class=\"btn " + btn_theme_css + "" + btn_size_css + "" + flag_css + "\" title=\"Flag as inappropriate\"><i class=\"icon-flag" + btn_icon_css +"\"></i></button>\n");
            str.Append("</div>\n");
        }
        if (this.isDetailViewStats)
        {
            stat_path = _rootpath + "handlers/media/statistics.ashx";
            stat_parameters = "vid=" + this.ContentID + "&lk=" + this.Liked + "&dlk=" + this.Disliked + "&cmt=" + this.Comments + "&fvt=" + this.Favorites + "&vw=" + this.Views;
      
            str.Append("<div class=\"btn-group pull-right\">\n");
            str.Append("<button class=\"btn " + btn_theme_css + "" + btn_size_css + " istats\"  title=\"View " + Content_Type + " statistics\"><i class=\"icon-signal" + btn_icon_css + "\"></i></button>\n");
            str.Append("</div>\n");
        }
        if (this.PhotoOptions)
        {
            str.Append("<div class=\"btn-group pull-right\">\n");
            str.Append("<a href=\"" + this.PhotoDownloadLink + "\" class=\"btn " + btn_theme_css + "" + btn_size_css + "\"  title=\"resize and download photo\">Download</a>\n");

            str.Append("</div>\n");
        }
        if (this.isViews)
        {
            int ptop = 5;
            if (this.ToolbarSize == 2)
                ptop = 8;
            string _views = "0";
            if (this.Views > 0)
                _views = string.Format("{0:#,###}", this.Views);
            str.Append("<div class=\"btn-group pull-right\" style=\"padding-top:" + ptop + "px;\">\n");
            str.Append("<span class=\"xbig-text\">" + _views + "</span>");
            str.Append("</div>\n");
        }
        if (this.PhotoGalleryOptions) // custom photo gallery options
        {
            str.Append("<div class=\"btn-group pull-right\">\n");
            string link = this.GalleryDefaultLink;
            string olink = this.GalleryDefaultLink + "?org=on";
            string slink = this.GalleryDefaultLink + "?slidshow=on";
            if (this.ShowOriginalButton)
                str.Append("<a href=\"" + olink + "\" class=\"btn " + btn_theme_css + "" + btn_size_css + "\"  title=\"original photo preview\">Original</a>\n");
            if (this.ShowNormalButton)
                str.Append("<a href=\"" + link + "\" class=\"btn " + btn_theme_css + "" + btn_size_css + "\"  title=\"normal photo preview\">Normal</a>\n");
            if (this.ShowSlideShowButton)
                str.Append("<a href=\"" + slink + "\" class=\"btn " + btn_theme_css + "" + btn_size_css + "\"  title=\"start slideshow\">SlideShow</a>\n");
            str.Append("</div>\n");
        }
       
        str.Append("</div>\n"); // --> Toolbar
        widget.InnerHtml = str.ToString();
    }

    private int Calculate_Ratings()
    {
        return (int)this.Avg_Ratings * 24; // 24x24 each rating size
    }
   
}