﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

using System.Collections.Generic;
using System.Text;

public partial class modules_archives : System.Web.UI.UserControl
{
    // CSS Properties
    public int BoxTemplate = 0; // Default,
    public string BoxCssClass = ""; // main box css style
    public string HeadingCssClass = ""; // main box heading css style
    public string BodyCssClass = ""; // main body section css style
    public string CssClass = ""; // Provide link css class
    public string ActiveCssClass = "xmedium-text bold"; // provide active link css class
    public string ListingCssClass = "ver_lst"; // "flow_lst" // ver_lst
    // Other Properties
    public bool isHeading = true; // Enable / Disable Heading
    public string HeadingTitle = Resources.vsk.archives;
    public int TotalColumns = 2; // Display records in n level of columns

    public bool isAll = false; // true to load all links
    public bool isMainProfile = false; // true: use single archive profile for all contents
    // URL Properties
    public string MoreLinkUrl = "";
    public string MoreLinkText = Resources.vsk.seeall;
    public string LinkToolTip = "";
    public string MoreLinkToolTip = "";
    public int TotalRecords = 6;
    public int isAudio = 0; // 0: video, 1: audio
    public int Type = 0; // 0: videos, 1: groups, 5: photos, 6: blogs, 7: audio files, 8: Galleries, 9: Forums
    public int GalleryType = 0; //Photo Gallery, 1: Video Album, 2: Audio Album
    public string URL = "";
    protected void Page_PreRender(object sender, EventArgs e)
    {
        // Toggle on | off archive section
        if (!Config.isFeature_Archives())
        {
            widget.Visible = false;
            return;
        }

        if (this.BoxCssClass == "")
            PrepareBoxTemplates();

        // apply box css on main class
        widget.Attributes.Add("class", this.BoxCssClass + " " + this.ListingCssClass); // add css class to widget item

        if (!Page.IsPostBack)
        {
            htitle.InnerHtml = this.HeadingTitle;
            BindList();
        }
    }

    private void BindList()
    {
        if (this.isHeading)
        {
            hd.Attributes.Add("class", HeadingCssClass);
            htitle.InnerHtml = this.HeadingTitle;
        }

        List<Archive_Struct> _list = null;
        switch (this.Type)
        {
            case 0:
                // videos
                _list = VideoBLL.Load_Arch_List(this.isAudio,this.TotalRecords,this.isAll);
                break;
            
            case 7:
                // audio files
                this.isAudio = 1;
                _list = VideoBLL.Load_Arch_List(this.TotalRecords, this.isAudio, this.isAll);
                break;
           
        }
       
        if (_list.Count > 0)
        {
            StringBuilder str = new StringBuilder();
            int i = 0;
            int counter = 0;
            int total_column_records = Convert.ToInt32(Math.Floor((double)_list.Count / this.TotalColumns));
            int sectionwidth = 30;
            if (this.TotalColumns == 2)
                sectionwidth = 49;
            else if (this.TotalColumns == 4)
                sectionwidth = 24;
            else if (this.TotalColumns == 1)
                sectionwidth = 100;
            str.Append("<div class=\"bx_br_bt item_pad_4\">\n");
            str.Append("<div class=\"" + this.ListingCssClass + "\" style=\"float: left; width:" + sectionwidth + "%;\"><ul>\n");
            for (i = 0; i <= _list.Count - 1; i++)
            {
                string _class = "";
                if (_list[i].Month.ToString() == Request.Params["m"] && _list[i].Year.ToString() == Request.Params["y"])
                    _class = "class=\"" + this.ActiveCssClass + "\"";

                string _url = "";
                if (this.URL != "")
                    _url = Parse_TAGUrl_URL(this.URL, _list[i].Month.ToString(), _list[i].Year.ToString());
                else
                    _url = UrlConfig.Prepare_Archive_Url(_list[i].Year, _list[i].Month, _list[i].MonthName, this.Type, this.isMainProfile);
        
                str.Append("<li><a href=\"" + _url + "\" " + _class + " title=\"" + this.LinkToolTip + " added in " + _list[i].MonthName + " " + _list[i].Year + "\">" + _list[i].MonthName + " " + _list[i].Year + "</a></li>");
                counter++;
                if (counter >= total_column_records)
                {
                    str.Append("</ul></div>\n");
                    str.Append("<div class=\"" + this.ListingCssClass + "\" style=\"float: left; width: " + sectionwidth + "%;\"><ul>\n");
                    counter = 0;
                }
            }
            str.Append("</ul></div>");
            str.Append("<div class=\"clear\"></div>\n");
            str.Append("</div>\n");
            if (!this.isAll && this.MoreLinkUrl !="")
            {
                str.Append("<div class=\"item_pad_4_r\"><a href=\"" + Config.GetUrl(this.MoreLinkUrl) + "\" Title=\"" + this.MoreLinkToolTip + "\">" + this.MoreLinkText + "</a></div>");
            }
            
            lst.InnerHtml = str.ToString();
        }

        else
        {
            widget.Visible = false;
        }
    }

    private void PrepareBoxTemplates()
    {
        this.BoxCssClass = UGeneral.Return_Box_Css(this.BoxTemplate);
        this.HeadingCssClass = UGeneral.Return_Heading_Css(this.BoxTemplate);
    }

    // replace [MN] with term or categoryname, [YR] with categoryid
    public string Parse_TAGUrl_URL(string input, string month, string year)
    {
        input = System.Text.RegularExpressions.Regex.Replace(input, @"\[MN\]", month);
        return System.Text.RegularExpressions.Regex.Replace(input, @"\[YR\]", year);
    }
}
