﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class video2_modules_related : System.Web.UI.UserControl
{
    public long AlbumId = 0;
    private long _videoid = 0;
    private int _mediatype = 0; // 0: video, 1: audio
    private string _title = "";
    private string _tags = "";
    private int _categoryid = 0;

    public long VideoID
    {
        set { _videoid = value; }
        get { return _videoid; }
    }

    public int MediaType
    {
        set { _mediatype = value; }
        get { return _mediatype; }
    }

    public int CategoryID
    {
        set { _categoryid = value; }
        get { return _categoryid; }
    }

    public string Title
    {
        set { _title = value; }
        get { return _title; }
    }
    public string Tags
    {
        set { _tags = value; }
        get { return _tags; }
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            string _mtype = "Videos";
            if(this.MediaType==1)
                _mtype="Audio Files";
            if (this.AlbumId > 0)
                cmt.InnerHtml = "More Album " + _mtype;
            else
                cmt.InnerHtml = "Suggestions";
            Load_Suggestions();
        }
    }

    private void Load_Suggestions()
    {
        StringBuilder str = new StringBuilder();
        StringBuilder rotator_str = new StringBuilder();
        if (!Site_Settings.Filter_Related_Search)
            this.CategoryID = 0; // remove category related filteration.

        List<Video_Struct> _list = VideoBLL.Load_Related_Videos(this.Title, this.Tags, this.VideoID, this.MediaType,this.AlbumId);
        if (_list.Count > 0)
        {
            // load comments
            int i = 0;
            VideoItem video = new VideoItem();
            for (i = 0; i <= _list.Count - 1; i++)
            {
                // generate thumb rotator script for single video item                
                rotator_str.Append(UGeneral.Generate_Thumb_Rotator_Script(_list[i].ThumbFileName));
                //video.BreakLine = true;
                video.ShowDate = false;
                video.ShowTitle = true;
                video.ShowAuthor = true;
                video.ShowViews = true;
                video.ShowDownloads = false;
                video.BoxWidth = 0;
                video.Width = 121;
                video.Height = 68;
                video.BoxSpace =0;
                video.isAdmin = false;
                video.isHoverEffect = true;
                video.TitleLength = 40;
                video.ContentLayout = 1; // 0: contents on bottom, 1: contents on left;
                video.LeftWidth = 45; // % // works with contentlayout=1;
                video.RightWidth = 54; // % // works with contentlayout=1;
                video.Type = this.MediaType;
                if (_list[i].isFeatured == 1)
                {
                    //video.ShowFeatured = true; // mark current item as featured
                    video.isAltColor = true; // highligh feature item backgroun
                }
                else
                {
                    video.isAltColor = false;
                }

                str.Append(video.Process(_list[i]));
            }
            str.Append("<div class=\"clear\"></div>"); // clear floating items
            str.Append("<script type=\"text/javascript\">" + rotator_str.ToString() + "</script>"); // thumb rotator script
            main.InnerHtml = str.ToString();
        }
        else
        {
            widget.Visible = false;
        }
    }
}