﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

using System.Collections.Generic;
using System.Text;
public partial class video_responses_Default : System.Web.UI.Page
{
    protected string VideoItem = ""; // Set Video Item shown on top of video response listing
    private VideoBLL _mediadalc = new VideoBLL();

    protected void Page_Load(object sender, EventArgs e)
    {

        if (!Page.IsPostBack)
        {
            if (Request.Params["vid"] == null || Request.Params["vid"] == "" || !UtilityBLL.isDigit(Request.Params["vid"].ToString()))
            {
                Response.Redirect( Config.GetUrl());
                return;
            }

            // SET VideoID -> Used through out page
            long VideoID =Convert.ToInt32(Request.Params["vid"]);

            // Load Video Information
            Load_Video_Information(VideoID);

        }
    }

    private void Load_Video_Information(long VideoID)
    {
        StringBuilder str = new StringBuilder();
        StringBuilder rotator_str = new StringBuilder();
        List<Video_Struct> _list = _mediadalc.Fetch_Record_SM(VideoID);
        if (_list.Count > 0)
        {
            // video thumb setup.
            int i = 0;
            str.Append("<div class=\"item_pad_4\">");
            VideoItem video = new VideoItem();
            for (i = 0; i <= _list.Count - 1; i++)
            {
                // generate thumb rotator script for single video item                
                rotator_str.Append(UGeneral.Generate_Thumb_Rotator_Script(_list[i].ThumbFileName));
                // single comment item
                video.ShowDate = false;
                video.ShowTitle = true;
                video.ShowAuthor = true;
                video.ShowViews = false;
                video.ShowDownloads = false;
                video.BoxWidth = 145;
                video.Width = 135;
                video.Height = 72;
                video.BoxSpace = 10;
                video.isAdmin = false;
                video.isHoverEffect = false;
                video.TitleLength = 0;
                video.ContentLayout = 1;
                video.BoxWidth = 0;
                video.LeftWidth = 25; // %
                video.RightWidth = 74; // %
                _list[0].VideoID = VideoID;
                str.Append(video.Process(_list[i]));

            }
            str.Append("</div>");
            str.Append("<div class=\"clear\"></div>"); // clear floating items
            str.Append("<script type=\"text/javascript\">" + rotator_str.ToString() + "</script>"); // thumb rotator script
            this.VideoItem = str.ToString();



            // video responses
            vr_all1.VideoID = VideoID;
            vr_all1.VideoResponses = _list[0].Responses;

            // set meta information
            string meta_title = _list[0].Title + " Responses";
            if (meta_title == "")
                meta_title = "Audio File No " + _list[0].VideoID + " Responses";
            string _description = _list[0].Description;
            if (_description == "")
                _description = _list[0].Title;
            string meta_description = _description + ", " + _list[0].Responses + " response on this video, AID: " + _list[0].VideoID;
            MetaTagsBLL.META_StaticPage(this.Page, (HtmlHead)Page.Header, meta_title, meta_description, _list[0].Thumb_Url, UrlConfig.Prepare_Video_Preview_Url(_list[0].VideoID, _list[0].Title, false));
        }
        else
        {
            main.Visible = false;
            Config.ShowMessageV2(msg, Resources.vsk.message_05, "Error!", 0); // Record does't exist, may be blocked by administrator
        }
    }
}
