﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class videos_modules_nav_navigation : System.Web.UI.UserControl
{
    public int MediaType = 0; // 0: video, 1: audio
    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            string _path = "videos";
            string _mtype = "Videos";
            if (MediaType == 1)
            {
                _path = "audio";
                _mtype = "Audio";
            }

            txt_search.Attributes.Add("placeholder", "Search " + _mtype + "");

            if (categories1 != null)
            {
                categories1.ShowParentsOnly = false; // Enable Disable Child Categories on Short Listing

                categories1.URL = Config.GetUrl(_path + "/category/[CN].aspx");
                if (MediaType == 1)
                    categories1.Type = 7; // audio categories
                else
                    categories1.Type = 0; // video categories
                categories1.MainCategoryURL = false;
                categories1.NavigationCssClass = "";

                categories1.isHeading = true;
                categories1.HeadingTitle = _mtype + " Categories";
                categories1.isAll = false;
                categories1.MultiColumn = true;
                categories1.TotalColumns = 1;
                categories1.RepeatDirection = 0;
                categories1.ColumnWidth = "100%";

                categories1.DirectoryBoxCssClass = "item"; // "boxcssclass"; in case of multiple columns to add space between two boxes

                if (categories1.ShowParentsOnly)
                {
                    categories1.Total_Records = 10;
                    categories1.ListingCssClass = "ver_lstt"; // inline ul li listing
                    categories1.ParentCssClass = "normal-text bold";
                }
                else
                {
                    categories1.ListingCssClass = "item";
                    categories1.ParentCssClass = "medium-text bold reverse";
                    categories1.TotalChilds = 3;
                    categories1.TotalParents = 4;
                    categories1.RepeatDirection = 1;
                    categories1.UlChildCssClass = "nav nav-list";
                    categories1.ParentBoxCssClass = "well-spad";
                    categories1.ChildBoxCssClass = "item";
                }
                categories1.Order = "priority desc";

                categories1.MoreLinkToolTip = "Browse more video categories";
                // categories1.MoreLinkUrl = _path + "/categories/";
                categories1.MoreLinkUrl = "categories/";
            }
            asearch.HRef = Config.GetUrl(_path + "/searchoptions.aspx");
            // featured videos
            vd_sm1.isAudio = this.MediaType;
            vd_sm1.HeadingTitle = "Featured " + _mtype;
            vd_sm1.isfeatured = 1; // 0: normal, 1: featured, 2: all, 3: premium
            vd_sm1.isCache = true;
            vd_sm1.Order = "date_added desc";
            vd_sm1.See_All_Url =  _path + "/featured/";
            vd_sm1.See_All_Url_Tooltip = "Browse all featured " + _mtype.ToLower() + "";
            vd_sm1.NoRecordFoundText = "No featured " + _mtype.ToLower() + " yet added!";
            vd_sm1.TotalColumns = 2;
            vd_sm1.Records = 4;
            vd_sm1.Width = 120;
            vd_sm1.Height = 72;
            vd_sm1.BoxWidth = 140;
            vd_sm1.BoxSpace = 10;
            vd_sm1.ShowTitle = true;
            vd_sm1.ShowDate = false;
            vd_sm1.ShowViews = false;
            vd_sm1.ShowUser = false;

            vd_sm2.isAudio = this.MediaType;
            vd_sm2.HeadingTitle = "Premium " + _mtype;
            vd_sm2.isfeatured = 3; // 0: normal, 1: featured, 2: all, 3: premium
            vd_sm2.isCache = true;
            vd_sm2.Order = "date_added desc";
            vd_sm2.See_All_Url = _path + "/premium/";
            vd_sm2.See_All_Url_Tooltip = "Browse all premium " + _mtype.ToLower();
            vd_sm2.NoRecordFoundText = "No premium " + _mtype.ToLower() + " yet added!";
            vd_sm2.TotalColumns = 2;
            vd_sm2.Records = 4;
            vd_sm2.Width = 120;
            vd_sm2.Height = 72;
            vd_sm2.BoxWidth = 140;
            vd_sm2.BoxSpace = 10;
            vd_sm2.ShowTitle = true;
            vd_sm2.ShowDate = false;
            vd_sm2.ShowViews = true;
            vd_sm2.ShowUser = false;

            //tags
            if (tags1 != null)
            {
                tags1.HeadingTitle = _mtype + " By Topics";
                if (MediaType == 1)
                    tags1.Type = 4;
                else
                    tags1.Type = 0;
                tags1.URL = Config.GetUrl(_path + "/tag/[CN].aspx");
                tags1.LinkToolTip = _mtype.ToLower() + " album";
            }
            if (archives1 != null)
            {
                // archives
                if (MediaType == 1)
                    archives1.Type = 7;
                else
                    archives1.Type = 0;
                archives1.MoreLinkUrl = _path + "/archive.aspx";
            }

        }
    }

    protected void btn_u_search_Click(object sender, EventArgs e)
    {
        if (txt_search.Text != "")
        {
            string _path = "videos";
            if (MediaType == 1)
            {
                _path = "audio";
            }
            Response.Redirect(Config.GetUrl(_path + "/search.aspx?query=" + Server.UrlEncode(UtilityBLL.CleanSearchTerm(txt_search.Text))));
        }
    }
}